/*
 * $Id$
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/Pattern_History_Table/include/Parameters.h"
#include "Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Two_Level_Branch_Predictor/Pattern_History_Table/include/Types.h"
#include <sstream>
using namespace std;

namespace morpheo                    {
namespace behavioural {
namespace core {
namespace multi_front_end {
namespace front_end {
namespace prediction_unit {
namespace direction {

namespace meta_predictor {
namespace two_level_branch_predictor {
namespace pattern_history_table {


  string Parameters::msg_error(void)
  {
    log_printf(FUNC,Pattern_History_Table,"msg_error","Begin");

    string msg = "";

    if (is_positive (_size_counter) == false)
      {
	msg += "  - size_counter must be > 0\n";
	msg += "    * size_counter                    : " + toString(_size_counter) + "\n";
      }

    if (is_positive (_nb_prediction) == false)
      {
	msg += "  - nb_prediction must be > 0\n";
	msg += "    * nb_prediction                   : " + toString(_nb_prediction) + "\n";
      }

    if (is_positive (_nb_branch_complete) == false)
      {
	msg += "  - nb_branch_complete must be > 0\n";
	msg += "    * nb_branch_complete              : " + toString(_nb_branch_complete) + "\n";
      }

    return msg;

    log_printf(FUNC,Pattern_History_Table,"msg_error","End");
  };

}; // end namespace pattern_history_table
}; // end namespace two_level_branch_predictor
}; // end namespace meta_predictor

}; // end namespace core
}; // end namespace multi_front_end
}; // end namespace front_end
}; // end namespace prediction_unit
}; // end namespace direction


}; // end namespace behavioural
}; // end namespace morpheo              
